//------------------------------------------------------------------------
// UNIT           : E950DrvXC_TLB.pas
// CONTENTS       : TE950Driver ActiveX control
// VERSION        : 1.0
// TARGET         : (Inprise's) Borland Delphi 4.0
// AUTHORS         : Konstantin Grishenko, Andrey Ivanov, Dmitry Myarikianov, Marco Cocco
// STATUS         : Freeware
//------------------------------------------------------------------------
//
// Copyright (c) 1996-98 by Konstantin Grishenko, Andrey Ivanov, Dmitry Myarikianov. All rights reseved.
// Copyright (c) 1996-98 by Marco Cocco. All rights reseved.
// Copyright (c) 1996-98 by d3k Software Company. All rights reseved.
//
// NO REPRESENTATIONS ARE MADE ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
//    PURPOSE. IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
//   NEITHER MARCO COCCO OR D3K SHALL BE LIABLE FOR ANY DAMAGES SUFFERED BY
//                          THE USE OF THIS SOFTWARE.
//

unit E950DriverXC_TLB;

// ************************************************************************ //
// WARNING                                                                  //
// -------                                                                  //
// The types declared in this file were generated from data read from a     //
// Type Library. If this type library is explicitly or indirectly (via      //
// another type library referring to this type library) re-imported, or the //
// 'Refresh' command of the Type Library Editor activated while editing the //
// Type Library, the contents of this file will be regenerated and all      //
// manual modifications will be lost.                                       //
// ************************************************************************ //

// PASTLWTR : $Revision:   1.11.1.75  $
// File generated on 10.09.1999 11:28:18 from Type Library described below.

// ************************************************************************ //
// Type Lib: C:\src\e950\epson950\ActiveX\E950DriverXC.tlb
// IID\LCID: {CA394501-2957-4662-9B64-92B4CBB0F218}\0
// Helpfile:
// HelpString: E950DriverXC Library
// Version:    1.0
// ************************************************************************ //

interface

uses Windows, ActiveX, Classes, Graphics, OleCtrls, StdVCL;

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:      //
//   Type Libraries     : LIBID_xxxx                                    //
//   CoClasses          : CLASS_xxxx                                    //
//   DISPInterfaces     : DIID_xxxx                                     //
//   Non-DISP interfaces: IID_xxxx                                      //
// *********************************************************************//
const
  LIBID_E950DriverXC: TGUID = '{CA394501-2957-4662-9B64-92B4CBB0F218}';
  IID_IE950DriverX: TGUID = '{228724D1-B324-478E-B223-3618076F838D}';
  DIID_IE950DriverXEvents: TGUID = '{CCB9AF31-BE6E-47E9-9270-7BD0CC851D4A}';
  CLASS_E950DriverX: TGUID = '{D7D7292F-8550-4AD7-B9C2-C7BE9B9F91BC}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                  //
// *********************************************************************//
// TxTypeCheck constants
type
  TxTypeCheck = TOleEnum;
const
  Service = $00000000;
  ServiceBack = $00000001;
  Payment = $00000002;
  PaymentBack = $00000003;
  Cashe = $00000004;
  CasheBack = $00000005;

// TxTypeDok constants
type
  TxTypeDok = TOleEnum;
const
  ServiceDok = $00000000;
  ServiceBackDok = $00000001;
  PaymentDok = $00000002;
  PaymentBackDok = $00000003;
  CasheDok = $00000004;
  CasheBackDok = $00000005;

// TxPortNumber constants
type
  TxPortNumber = TOleEnum;
const
  pnCustom = $00000000;
  pnCOM1 = $00000001;
  pnCOM2 = $00000002;
  pnCOM3 = $00000003;
  pnCOM4 = $00000004;
  pnCOM5 = $00000005;
  pnCOM6 = $00000006;
  pnCOM7 = $00000007;
  pnCOM8 = $00000008;
  pnCOM9 = $00000009;
  pnCOM10 = $0000000A;
  pnCOM11 = $0000000B;
  pnCOM12 = $0000000C;
  pnCOM13 = $0000000D;
  pnCOM14 = $0000000E;
  pnCOM15 = $0000000F;
  pnCOM16 = $00000010;

// TxBaudRate constants
type
  TxBaudRate = TOleEnum;
const
  brCustom = $00000000;
  br110 = $00000001;
  br300 = $00000002;
  br600 = $00000003;
  br1200 = $00000004;
  br2400 = $00000005;
  br4800 = $00000006;
  br9600 = $00000007;
  br14400 = $00000008;
  br19200 = $00000009;
  br38400 = $0000000A;
  br56000 = $0000000B;
  br57600 = $0000000C;
  br115200 = $0000000D;
  br128000 = $0000000E;
  br256000 = $0000000F;

// TxDataBits constants
type
  TxDataBits = TOleEnum;
const
  db5BITS = $00000000;
  db6BITS = $00000001;
  db7BITS = $00000002;
  db8BITS = $00000003;

// TxStopBits constants
type
  TxStopBits = TOleEnum;
const
  sb1BITS = $00000000;
  sb1HALFBITS = $00000001;
  sb2BITS = $00000002;

// TxParity constants
type
  TxParity = TOleEnum;
const
  ptNONE = $00000000;
  ptODD = $00000001;
  ptEVEN = $00000002;
  ptMARK = $00000003;
  ptSPACE = $00000004;

// TxHwFlowControl constants
type
  TxHwFlowControl = TOleEnum;
const
  hfNONE = $00000000;
  hfNONERTSON = $00000001;
  hfRTSCTS = $00000002;

// TxSwFlowControl constants
type
  TxSwFlowControl = TOleEnum;
const
  sfNONE = $00000000;
  sfXONXOFF = $00000001;

// TxAlignment constants
type
  TxAlignment = TOleEnum;
const
  taLeftJustify = $00000000;
  taRightJustify = $00000001;
  taCenter = $00000002;

// TxBiDiMode constants
type
  TxBiDiMode = TOleEnum;
const
  bdLeftToRight = $00000000;
  bdRightToLeft = $00000001;
  bdRightToLeftNoAlign = $00000002;
  bdRightToLeftReadingOnly = $00000003;

type

// *********************************************************************//
// Forward declaration of interfaces defined in Type Library            //
// *********************************************************************//
  IE950DriverX = interface;
  IE950DriverXDisp = dispinterface;
  IE950DriverXEvents = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                     //
// (NOTE: Here we map each CoClass to its Default Interface)            //
// *********************************************************************//
  E950DriverX = IE950DriverX;


// *********************************************************************//
// Interface: IE950DriverX
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {228724D1-B324-478E-B223-3618076F838D}
// *********************************************************************//
  IE950DriverX = interface(IDispatch)
    ['{228724D1-B324-478E-B223-3618076F838D}']
    function Connect: WordBool; safecall;
    procedure Disconnect; safecall;
    function Connected: WordBool; safecall;
    function IsPolling: WordBool; safecall;
    procedure PausePolling; safecall;
    procedure ContinuePolling; safecall;
    function FlushBuffers(inBuf: WordBool; outBuf: WordBool): WordBool; safecall;
    function CountRX: Integer; safecall;
    function OutFreeSpace: Smallint; safecall;
    procedure ToggleDTR(onOff: WordBool); safecall;
    procedure ToggleRTS(onOff: WordBool); safecall;
    procedure TestFBlock(PrintDok: WordBool; var CountBlock: Integer; var CountSuccBlock: Integer;
      var CountErrorBlock: Integer; var CountFreeBlock: Integer); safecall;
    procedure ReportDiag; safecall;
    procedure SetBlockWorkMem(SetOf: Integer; const InfoBlock: WideString); safecall;
    function GetBlockWorkMem(SetOf: Integer; LenBlock: Integer): WideString; safecall;
    procedure PrintTestPrinter; safecall;
    procedure ResetRegistrator; safecall;
    procedure GetStatusRegistrator(var LastFDok: Integer; var FirstDokDateTime: TDateTime;
      var LastClose: Integer; var CountFiskals: Integer;
      var VersionROM: WideString; var Lastdate: TDateTime;
      var SumMoney: Currency); safecall;
    procedure GetDmpSertificate(Send2Print: WordBool; var SN: WideString; var PosPoint: Integer;
      var Devaluations: Integer; var CurrDef: Integer;
      var TypePrn: Integer; var PasswordFiskal: WideString;
      var PasswordUser: WideString; var DateSer: TDateTime); safecall;
    procedure LoadSertificate(const SN: WideString; PosPoint: Integer; Devaluations: Integer;
      CurrDef: Integer; TypePrn: Integer; const PasswordFiskal: WideString;
      const PasswordUser: WideString; DateSer: TDateTime); safecall;
    procedure Certification; safecall;
    procedure GetDmpFiskal(SendToPrint: WordBool; var RN: WideString; var UserFR: WideString;
      var PasswordFiskal: WideString; var PasswordUser: WideString;
      var DateReg: TDateTime); safecall;
    procedure LoadFiskal(const RN: WideString; const UserFR: WideString;
      const PasswordFiskal: WideString; const PasswordUser: WideString;
      DateReg: Double); safecall;
    procedure Fiskalization; safecall;
    procedure GetFMemSize(var AllMem: Integer; var UsesMem: Integer); safecall;
    procedure CloseSmena(Fix: WordBool; var NumClose: Integer; var CountFCheckComplect: Integer;
      var CountFCheckNotComplect: Integer; var CountFDokComplect: Integer;
      var CountFDokNotComplect: Integer; var CountFDokAnulComplect: Integer;
      var CountCheckDokService: Integer; var SumSale: Currency;
      var SumMargin: Currency; var SumDiscount: Currency;
      var SumContainer: Currency; var CountCheckDokBack: Integer;
      var SumSaleBack: Currency; var SumMarginBack: Currency;
      var SumDiscountBack: Currency; var SumContainerBack: Currency;
      var CountCheckDokPayment: Integer; var SumPension: Currency;
      var SumTranslation: Currency; var SumComission: Currency;
      var CountCheckDokPaymentBack: Integer; var SumPensionBack: Currency;
      var SumTranslationBack: Currency; var SumComissionBack: Currency;
      var CountCheckDokCashe: Integer; var SumCashe: Currency;
      var CountCheckDokCasheBack: Integer; var SumCasheBack: Currency); safecall;
    procedure ReportOfDates(BeginDate: Double; EndDate: Double; ItogOnly: WordBool); safecall;
    procedure ReportOfSmena(BeginSmena: Integer; EndSmena: Integer; ItogOnly: WordBool); safecall;
    function ChangePassword(const PasswordOld: WideString; const PasswordNew: WideString): WideString; safecall;
    procedure OpenCheck(TypeCheck: TxTypeCheck; IndxCurr: Integer); safecall;
    procedure PrintFiskalTxt(IndxDesc: Integer; const FiskalTxt: WideString); safecall;
    procedure PrintFiskalStr(IndxDescStr: Integer; const DefineDescStr: WideString; Count: Double;
      IndxDescUM: Integer; Price: Currency; IndxDescCurr: Integer;
      const TypeStr: WideString; ProcMargine: Double; ProcDiscount: Double); safecall;
    procedure SubTotal(PrintSubTotal: WordBool; PrintCheck: WordBool; IndxDescSubTotal: Integer;
      const DefineSubTotal: WideString; IndxDescCurr: Integer;
      ProcMargine: Integer; ProcDiscount: Integer; var TypeCheck: TxTypeCheck;
      var CountLine: Integer; var TotalSale: Currency; var TotalMargine: Currency;
      var TotalDiscount: Currency; var TotalContainer: Currency;
      var InCash: Currency); safecall;
    function CheckTotal(InSum: Currency; IndxCurr: Integer; IndxOpl: Integer;
      const DefOpl: WideString; Tender: WordBool): Currency; safecall;
    function CloseCheck: Integer; safecall;
    procedure OpenNFCheck(IndxNCheck: Integer; const DefineDescNCheck: WideString); safecall;
    procedure PrintNFText(const Str: WideString); safecall;
    procedure CloseNFCheck; safecall;
    procedure CutNFCheck; safecall;
    procedure FeedLineCheck(CountLine: Integer); safecall;
    procedure FeedLineLog(CountLine: Integer); safecall;
    procedure FeedLineBoth(CountLine: Integer); safecall;
    procedure FeedLineDok(CountLine: Integer); safecall;
    procedure EjectDok; safecall;
    function ConditionSLIP(CountFreeLine: Integer; Pos1: Integer; Pos2: Integer): Integer; safecall;
    procedure FontPrn(Font: Integer); safecall;
    procedure OpenFDok(TDok: TxTypeDok; IndxDescCurr: Integer; CountFreeLine: Integer;
      PosHeader1: Integer; PosDisc: Integer; LenDisc: Integer;
      PosDefineDesc: Integer; LenDefineDesc: Integer; PosDescStr: Integer;
      LenDescStr: Integer; PosDefineStr: Integer; LenDefgineDescStr: Integer;
      PosSum: Integer; LenSum: Integer; PosDescTotal: Integer;
      LenDescTotal: Integer; PosDefineTotal: Integer; LenDefineToTal: Integer;
      PosSumTotal: Integer; LenSumTotal: Integer; PosHeader2: Integer); safecall;
    procedure PrintDefineFDok(IndxDesc: Integer; const DefineFDok: WideString); safecall;
    procedure PrintStrFDok(IndxDescStr: Integer; const DefineDescStr: WideString; Count: Double;
      IndxDescUM: Integer; Price: Currency; IndxDescCurr: Integer;
      const TypeStr: WideString; ProcMargine: Double; ProcDiscount: Double); safecall;
    procedure SubTotalFDok(PrintDok: WordBool; IndxDescSubTotal: Integer;
      const DefineSubTotal: WideString; IndDescCurr: Integer;
      ProcMargine: Double; ProcDiscount: Double; var TDok: TxTypeDok;
      var CountLine: Integer; var TotalSale: Currency;
      var TotalMargine: Currency; var TotalDiscount: Currency;
      var TotalContainer: Currency; var InCashe: Currency); safecall;
    function TotalFDok(InSum: Currency; IndxCurr: Integer; IndxOpl: Integer;
      const DefOpl: WideString; Tender: WordBool): Currency; safecall;
    function CloseFDok: Integer; safecall;
    procedure OpenNDok(IndxDesc: Integer; const DefIndxDesc: WideString; EmptyStr: Integer;
      PosHeader1: Integer; PosHeader2: Integer); safecall;
    procedure PrintNDokStr(const Str: WideString); safecall;
    procedure CloseNDok; safecall;
    function GetDefineDesc(NumTbl: Integer; NumDesc: Integer): WideString; safecall;
    procedure SetDefineDesc(NumTbl: Integer; NumDesc: Integer; const DefineDesc: WideString); safecall;
    function Get_TrainingState: WordBool; safecall;
    procedure Set_TrainingState(Value: WordBool); safecall;
    function Get_CashireName: WideString; safecall;
    procedure Set_CashireName(const Value: WideString); safecall;
    function Get_Password: WideString; safecall;
    procedure Set_Password(const Value: WideString); safecall;
    function Get_InspPassword: WideString; safecall;
    procedure Set_InspPassword(const Value: WideString); safecall;
    function Get_DateTimeFR: TDateTime; safecall;
    procedure Set_DateTimeFR(Value: TDateTime); safecall;
    function Get_ErrorStr: WideString; safecall;
    function Get_Port: TxPortNumber; safecall;
    procedure Set_Port(Value: TxPortNumber); safecall;
    function Get_PortName: WideString; safecall;
    procedure Set_PortName(const Value: WideString); safecall;
    function Get_BaudRate: TxBaudRate; safecall;
    procedure Set_BaudRate(Value: TxBaudRate); safecall;
    function Get_BaudRateValue: Integer; safecall;
    procedure Set_BaudRateValue(Value: Integer); safecall;
    function Get_DataBits: TxDataBits; safecall;
    procedure Set_DataBits(Value: TxDataBits); safecall;
    function Get_StopBits: TxStopBits; safecall;
    procedure Set_StopBits(Value: TxStopBits); safecall;
    function Get_Parity: TxParity; safecall;
    procedure Set_Parity(Value: TxParity); safecall;
    function Get_HwFlow: TxHwFlowControl; safecall;
    procedure Set_HwFlow(Value: TxHwFlowControl); safecall;
    function Get_SwFlow: TxSwFlowControl; safecall;
    procedure Set_SwFlow(Value: TxSwFlowControl); safecall;
    function Get_InBufSize: Integer; safecall;
    procedure Set_InBufSize(Value: Integer); safecall;
    function Get_OutBufSize: Integer; safecall;
    procedure Set_OutBufSize(Value: Integer); safecall;
    function Get_PollingDelay: Integer; safecall;
    procedure Set_PollingDelay(Value: Integer); safecall;
    function Get_EnableDTROnOpen: WordBool; safecall;
    procedure Set_EnableDTROnOpen(Value: WordBool); safecall;
    function Get_OutputTimeout: Integer; safecall;
    procedure Set_OutputTimeout(Value: Integer); safecall;
    function Get_InputTimeout: Integer; safecall;
    procedure Set_InputTimeout(Value: Integer); safecall;
    function Get_CheckLineStatus: WordBool; safecall;
    procedure Set_CheckLineStatus(Value: WordBool); safecall;
    function GetControlsAlignment: TxAlignment; safecall;
    function Get_DoubleBuffered: WordBool; safecall;
    procedure Set_DoubleBuffered(Value: WordBool); safecall;
    procedure FlipChildren(AllLevels: WordBool); safecall;
    function DrawTextBiDiModeFlags(Flags: Integer): Integer; safecall;
    function DrawTextBiDiModeFlagsReadingOnly: Integer; safecall;
    function Get_Enabled: WordBool; safecall;
    procedure Set_Enabled(Value: WordBool); safecall;
    procedure InitiateAction; safecall;
    function IsRightToLeft: WordBool; safecall;
    function UseRightToLeftAlignment: WordBool; safecall;
    function UseRightToLeftReading: WordBool; safecall;
    function UseRightToLeftScrollBar: WordBool; safecall;
    function Get_BiDiMode: TxBiDiMode; safecall;
    procedure Set_BiDiMode(Value: TxBiDiMode); safecall;
    function Get_Visible: WordBool; safecall;
    procedure Set_Visible(Value: WordBool); safecall;
    function Get_Cursor: Smallint; safecall;
    procedure Set_Cursor(Value: Smallint); safecall;
    function ClassNameIs(const Name: WideString): WordBool; safecall;
    function LR(const Param: WideString): WideString; safecall;
    function Get_HeaderCheck(ind: Integer): WideString; safecall;
    procedure Set_HeaderCheck(ind: Integer; const index: WideString); safecall;
    function GetHeaderCheck(idx: Integer): WideString; safecall;
    procedure SetHeaderCheck(idx: Integer; const newval: WideString); safecall;
    function Get_CashBox(BoxNo: Integer): WordBool; safecall;
    procedure Set_CashBox(BoxNo: Integer; Value: WordBool); safecall;
    procedure OpenCashBox(Ano: Integer); safecall;
    property TrainingState: WordBool read Get_TrainingState write Set_TrainingState;
    property CashireName: WideString read Get_CashireName write Set_CashireName;
    property Password: WideString read Get_Password write Set_Password;
    property InspPassword: WideString read Get_InspPassword write Set_InspPassword;
    property DateTimeFR: TDateTime read Get_DateTimeFR write Set_DateTimeFR;
    property ErrorStr: WideString read Get_ErrorStr;
    property Port: TxPortNumber read Get_Port write Set_Port;
    property PortName: WideString read Get_PortName write Set_PortName;
    property BaudRate: TxBaudRate read Get_BaudRate write Set_BaudRate;
    property BaudRateValue: Integer read Get_BaudRateValue write Set_BaudRateValue;
    property DataBits: TxDataBits read Get_DataBits write Set_DataBits;
    property StopBits: TxStopBits read Get_StopBits write Set_StopBits;
    property Parity: TxParity read Get_Parity write Set_Parity;
    property HwFlow: TxHwFlowControl read Get_HwFlow write Set_HwFlow;
    property SwFlow: TxSwFlowControl read Get_SwFlow write Set_SwFlow;
    property InBufSize: Integer read Get_InBufSize write Set_InBufSize;
    property OutBufSize: Integer read Get_OutBufSize write Set_OutBufSize;
    property PollingDelay: Integer read Get_PollingDelay write Set_PollingDelay;
    property EnableDTROnOpen: WordBool read Get_EnableDTROnOpen write Set_EnableDTROnOpen;
    property OutputTimeout: Integer read Get_OutputTimeout write Set_OutputTimeout;
    property InputTimeout: Integer read Get_InputTimeout write Set_InputTimeout;
    property CheckLineStatus: WordBool read Get_CheckLineStatus write Set_CheckLineStatus;
    property DoubleBuffered: WordBool read Get_DoubleBuffered write Set_DoubleBuffered;
    property Enabled: WordBool read Get_Enabled write Set_Enabled;
    property BiDiMode: TxBiDiMode read Get_BiDiMode write Set_BiDiMode;
    property Visible: WordBool read Get_Visible write Set_Visible;
    property Cursor: Smallint read Get_Cursor write Set_Cursor;
    property HeaderCheck[ind: Integer]: WideString read Get_HeaderCheck write Set_HeaderCheck;
    property CashBox[BoxNo: Integer]: WordBool read Get_CashBox write Set_CashBox;
  end;

// *********************************************************************//
// DispIntf:  IE950DriverXDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {228724D1-B324-478E-B223-3618076F838D}
// *********************************************************************//
  IE950DriverXDisp = dispinterface
    ['{228724D1-B324-478E-B223-3618076F838D}']
    function Connect: WordBool; dispid 1;
    procedure Disconnect; dispid 2;
    function Connected: WordBool; dispid 3;
    function IsPolling: WordBool; dispid 4;
    procedure PausePolling; dispid 5;
    procedure ContinuePolling; dispid 6;
    function FlushBuffers(inBuf: WordBool; outBuf: WordBool): WordBool; dispid 7;
    function CountRX: Integer; dispid 8;
    function OutFreeSpace: Smallint; dispid 9;
    procedure ToggleDTR(onOff: WordBool); dispid 10;
    procedure ToggleRTS(onOff: WordBool); dispid 11;
    procedure TestFBlock(PrintDok: WordBool; var CountBlock: Integer; var CountSuccBlock: Integer;
      var CountErrorBlock: Integer; var CountFreeBlock: Integer); dispid 12;
    procedure ReportDiag; dispid 14;
    procedure SetBlockWorkMem(SetOf: Integer; const InfoBlock: WideString); dispid 15;
    function GetBlockWorkMem(SetOf: Integer; LenBlock: Integer): WideString; dispid 16;
    procedure PrintTestPrinter; dispid 17;
    procedure ResetRegistrator; dispid 18;
    procedure GetStatusRegistrator(var LastFDok: Integer; var FirstDokDateTime: TDateTime;
      var LastClose: Integer; var CountFiskals: Integer;
      var VersionROM: WideString; var Lastdate: TDateTime;
      var SumMoney: Currency); dispid 19;
    procedure GetDmpSertificate(Send2Print: WordBool; var SN: WideString; var PosPoint: Integer;
      var Devaluations: Integer; var CurrDef: Integer;
      var TypePrn: Integer; var PasswordFiskal: WideString;
      var PasswordUser: WideString; var DateSer: TDateTime); dispid 20;
    procedure LoadSertificate(const SN: WideString; PosPoint: Integer; Devaluations: Integer;
      CurrDef: Integer; TypePrn: Integer; const PasswordFiskal: WideString;
      const PasswordUser: WideString; DateSer: TDateTime); dispid 21;
    procedure Certification; dispid 22;
    procedure GetDmpFiskal(SendToPrint: WordBool; var RN: WideString; var UserFR: WideString;
      var PasswordFiskal: WideString; var PasswordUser: WideString;
      var DateReg: TDateTime); dispid 23;
    procedure LoadFiskal(const RN: WideString; const UserFR: WideString;
      const PasswordFiskal: WideString; const PasswordUser: WideString;
      DateReg: Double); dispid 24;
    procedure Fiskalization; dispid 25;
    procedure GetFMemSize(var AllMem: Integer; var UsesMem: Integer); dispid 26;
    procedure CloseSmena(Fix: WordBool; var NumClose: Integer; var CountFCheckComplect: Integer;
      var CountFCheckNotComplect: Integer; var CountFDokComplect: Integer;
      var CountFDokNotComplect: Integer; var CountFDokAnulComplect: Integer;
      var CountCheckDokService: Integer; var SumSale: Currency;
      var SumMargin: Currency; var SumDiscount: Currency;
      var SumContainer: Currency; var CountCheckDokBack: Integer;
      var SumSaleBack: Currency; var SumMarginBack: Currency;
      var SumDiscountBack: Currency; var SumContainerBack: Currency;
      var CountCheckDokPayment: Integer; var SumPension: Currency;
      var SumTranslation: Currency; var SumComission: Currency;
      var CountCheckDokPaymentBack: Integer; var SumPensionBack: Currency;
      var SumTranslationBack: Currency; var SumComissionBack: Currency;
      var CountCheckDokCashe: Integer; var SumCashe: Currency;
      var CountCheckDokCasheBack: Integer; var SumCasheBack: Currency); dispid 27;
    procedure ReportOfDates(BeginDate: Double; EndDate: Double; ItogOnly: WordBool); dispid 28;
    procedure ReportOfSmena(BeginSmena: Integer; EndSmena: Integer; ItogOnly: WordBool); dispid 29;
    function ChangePassword(const PasswordOld: WideString; const PasswordNew: WideString): WideString; dispid 30;
    procedure OpenCheck(TypeCheck: TxTypeCheck; IndxCurr: Integer); dispid 31;
    procedure PrintFiskalTxt(IndxDesc: Integer; const FiskalTxt: WideString); dispid 32;
    procedure PrintFiskalStr(IndxDescStr: Integer; const DefineDescStr: WideString; Count: Double;
      IndxDescUM: Integer; Price: Currency; IndxDescCurr: Integer;
      const TypeStr: WideString; ProcMargine: Double; ProcDiscount: Double); dispid 33;
    procedure SubTotal(PrintSubTotal: WordBool; PrintCheck: WordBool; IndxDescSubTotal: Integer;
      const DefineSubTotal: WideString; IndxDescCurr: Integer;
      ProcMargine: Integer; ProcDiscount: Integer; var TypeCheck: TxTypeCheck;
      var CountLine: Integer; var TotalSale: Currency; var TotalMargine: Currency;
      var TotalDiscount: Currency; var TotalContainer: Currency;
      var InCash: Currency); dispid 34;
    function CheckTotal(InSum: Currency; IndxCurr: Integer; IndxOpl: Integer;
      const DefOpl: WideString; Tender: WordBool): Currency; dispid 35;
    function CloseCheck: Integer; dispid 36;
    procedure OpenNFCheck(IndxNCheck: Integer; const DefineDescNCheck: WideString); dispid 37;
    procedure PrintNFText(const Str: WideString); dispid 38;
    procedure CloseNFCheck; dispid 39;
    procedure CutNFCheck; dispid 40;
    procedure FeedLineCheck(CountLine: Integer); dispid 41;
    procedure FeedLineLog(CountLine: Integer); dispid 42;
    procedure FeedLineBoth(CountLine: Integer); dispid 43;
    procedure FeedLineDok(CountLine: Integer); dispid 44;
    procedure EjectDok; dispid 45;
    function ConditionSLIP(CountFreeLine: Integer; Pos1: Integer; Pos2: Integer): Integer; dispid 46;
    procedure FontPrn(Font: Integer); dispid 47;
    procedure OpenFDok(TDok: TxTypeDok; IndxDescCurr: Integer; CountFreeLine: Integer;
      PosHeader1: Integer; PosDisc: Integer; LenDisc: Integer;
      PosDefineDesc: Integer; LenDefineDesc: Integer; PosDescStr: Integer;
      LenDescStr: Integer; PosDefineStr: Integer; LenDefgineDescStr: Integer;
      PosSum: Integer; LenSum: Integer; PosDescTotal: Integer;
      LenDescTotal: Integer; PosDefineTotal: Integer; LenDefineToTal: Integer;
      PosSumTotal: Integer; LenSumTotal: Integer; PosHeader2: Integer); dispid 48;
    procedure PrintDefineFDok(IndxDesc: Integer; const DefineFDok: WideString); dispid 49;
    procedure PrintStrFDok(IndxDescStr: Integer; const DefineDescStr: WideString; Count: Double;
      IndxDescUM: Integer; Price: Currency; IndxDescCurr: Integer;
      const TypeStr: WideString; ProcMargine: Double; ProcDiscount: Double); dispid 50;
    procedure SubTotalFDok(PrintDok: WordBool; IndxDescSubTotal: Integer;
      const DefineSubTotal: WideString; IndDescCurr: Integer;
      ProcMargine: Double; ProcDiscount: Double; var TDok: TxTypeDok;
      var CountLine: Integer; var TotalSale: Currency;
      var TotalMargine: Currency; var TotalDiscount: Currency;
      var TotalContainer: Currency; var InCashe: Currency); dispid 51;
    function TotalFDok(InSum: Currency; IndxCurr: Integer; IndxOpl: Integer;
      const DefOpl: WideString; Tender: WordBool): Currency; dispid 52;
    function CloseFDok: Integer; dispid 53;
    procedure OpenNDok(IndxDesc: Integer; const DefIndxDesc: WideString; EmptyStr: Integer;
      PosHeader1: Integer; PosHeader2: Integer); dispid 54;
    procedure PrintNDokStr(const Str: WideString); dispid 55;
    procedure CloseNDok; dispid 56;
    function GetDefineDesc(NumTbl: Integer; NumDesc: Integer): WideString; dispid 57;
    procedure SetDefineDesc(NumTbl: Integer; NumDesc: Integer; const DefineDesc: WideString); dispid 58;
    property TrainingState: WordBool dispid 59;
    property CashireName: WideString dispid 60;
    property Password: WideString dispid 61;
    property InspPassword: WideString dispid 62;
    property DateTimeFR: TDateTime dispid 63;
    property ErrorStr: WideString readonly dispid 64;
    property Port: TxPortNumber dispid 65;
    property PortName: WideString dispid 66;
    property BaudRate: TxBaudRate dispid 67;
    property BaudRateValue: Integer dispid 68;
    property DataBits: TxDataBits dispid 69;
    property StopBits: TxStopBits dispid 70;
    property Parity: TxParity dispid 71;
    property HwFlow: TxHwFlowControl dispid 72;
    property SwFlow: TxSwFlowControl dispid 73;
    property InBufSize: Integer dispid 74;
    property OutBufSize: Integer dispid 75;
    property PollingDelay: Integer dispid 76;
    property EnableDTROnOpen: WordBool dispid 77;
    property OutputTimeout: Integer dispid 78;
    property InputTimeout: Integer dispid 79;
    property CheckLineStatus: WordBool dispid 80;
    function GetControlsAlignment: TxAlignment; dispid 81;
    property DoubleBuffered: WordBool dispid 84;
    procedure FlipChildren(AllLevels: WordBool); dispid 85;
    function DrawTextBiDiModeFlags(Flags: Integer): Integer; dispid 88;
    function DrawTextBiDiModeFlagsReadingOnly: Integer; dispid 89;
    property Enabled: WordBool dispid - 514;
    procedure InitiateAction; dispid 91;
    function IsRightToLeft: WordBool; dispid 92;
    function UseRightToLeftAlignment: WordBool; dispid 97;
    function UseRightToLeftReading: WordBool; dispid 98;
    function UseRightToLeftScrollBar: WordBool; dispid 99;
    property BiDiMode: TxBiDiMode dispid 100;
    property Visible: WordBool dispid 101;
    property Cursor: Smallint dispid 102;
    function ClassNameIs(const Name: WideString): WordBool; dispid 106;
    function LR(const Param: WideString): WideString; dispid 83;
    property HeaderCheck[ind: Integer]: WideString dispid 13;
    function GetHeaderCheck(idx: Integer): WideString; dispid 82;
    procedure SetHeaderCheck(idx: Integer; const newval: WideString); dispid 86;
    property CashBox[BoxNo: Integer]: WordBool dispid 90;
    procedure OpenCashBox(Ano: Integer); dispid 87;
  end;

// *********************************************************************//
// DispIntf:  IE950DriverXEvents
// Flags:     (4096) Dispatchable
// GUID:      {CCB9AF31-BE6E-47E9-9270-7BD0CC851D4A}
// *********************************************************************//
  IE950DriverXEvents = dispinterface
    ['{CCB9AF31-BE6E-47E9-9270-7BD0CC851D4A}']
    procedure BeforeOpenCheck; dispid 3;
    procedure AfterOpenCheck; dispid 4;
    procedure BeforePrnTxtCheck; dispid 5;
    procedure AfterPrnTxtCheck; dispid 6;
    procedure BeforePrnStrCheck; dispid 7;
    procedure AfterPrnStrCheck; dispid 8;
    procedure BeforePrnSubTotalCheck; dispid 9;
    procedure AfterPrnSubTotalCheck; dispid 10;
    procedure BeforePrnTotalCheck; dispid 11;
    procedure AfterPrnTotalCheck; dispid 12;
    procedure BeforeCloseCheck; dispid 13;
    procedure AfterCloseCheck; dispid 14;
    procedure BeforeOpenNCheck; dispid 15;
    procedure AfterOpenNCheck; dispid 16;
    procedure BeforePrnTxtNCheck; dispid 17;
    procedure AfterPrnTxtNCheck; dispid 18;
    procedure BeforeCloseNCheck; dispid 19;
    procedure AfterCloseNCheck; dispid 20;
    procedure BeforeOpenDok; dispid 21;
    procedure AfterOpenDok; dispid 22;
    procedure BeforePrnTxtDok; dispid 23;
    procedure AfterPrnTxtDok; dispid 24;
    procedure BeforePrnStrDok; dispid 25;
    procedure AfterPrnStrDok; dispid 26;
    procedure BeforePrnSubTotalDok; dispid 27;
    procedure AfterPrnSubTotalDok; dispid 28;
    procedure BeforePrnTotalDok; dispid 29;
    procedure AfterPrnTotalDok; dispid 30;
    procedure BeforeCloseDok; dispid 31;
    procedure AfterCloseDok; dispid 32;
    procedure BeforeOpenNDok; dispid 33;
    procedure AfterOpenNDok; dispid 34;
    procedure BeforePrnTxtNDok; dispid 35;
    procedure AfterPrnTxtNDok; dispid 36;
    procedure BeforeCloseNDok; dispid 37;
    procedure AfterCloseNDok; dispid 38;
    procedure OnError; dispid 39;
  end;


// *********************************************************************//
// OLE Control Proxy class declaration
// Control Name     : TE950DriverX
// Help String      : E950DriverX Control
// Default Interface: IE950DriverX
// Def. Intf. DISP? : No
// Event   Interface: IE950DriverXEvents
// TypeFlags        : (34) CanCreate Control
// *********************************************************************//
  TE950DriverX = class(TOleControl)
  private
    FOnBeforeOpenCheck: TNotifyEvent;
    FOnAfterOpenCheck: TNotifyEvent;
    FOnBeforePrnTxtCheck: TNotifyEvent;
    FOnAfterPrnTxtCheck: TNotifyEvent;
    FOnBeforePrnStrCheck: TNotifyEvent;
    FOnAfterPrnStrCheck: TNotifyEvent;
    FOnBeforePrnSubTotalCheck: TNotifyEvent;
    FOnAfterPrnSubTotalCheck: TNotifyEvent;
    FOnBeforePrnTotalCheck: TNotifyEvent;
    FOnAfterPrnTotalCheck: TNotifyEvent;
    FOnBeforeCloseCheck: TNotifyEvent;
    FOnAfterCloseCheck: TNotifyEvent;
    FOnBeforeOpenNCheck: TNotifyEvent;
    FOnAfterOpenNCheck: TNotifyEvent;
    FOnBeforePrnTxtNCheck: TNotifyEvent;
    FOnAfterPrnTxtNCheck: TNotifyEvent;
    FOnBeforeCloseNCheck: TNotifyEvent;
    FOnAfterCloseNCheck: TNotifyEvent;
    FOnBeforeOpenDok: TNotifyEvent;
    FOnAfterOpenDok: TNotifyEvent;
    FOnBeforePrnTxtDok: TNotifyEvent;
    FOnAfterPrnTxtDok: TNotifyEvent;
    FOnBeforePrnStrDok: TNotifyEvent;
    FOnAfterPrnStrDok: TNotifyEvent;
    FOnBeforePrnSubTotalDok: TNotifyEvent;
    FOnAfterPrnSubTotalDok: TNotifyEvent;
    FOnBeforePrnTotalDok: TNotifyEvent;
    FOnAfterPrnTotalDok: TNotifyEvent;
    FOnBeforeCloseDok: TNotifyEvent;
    FOnAfterCloseDok: TNotifyEvent;
    FOnBeforeOpenNDok: TNotifyEvent;
    FOnAfterOpenNDok: TNotifyEvent;
    FOnBeforePrnTxtNDok: TNotifyEvent;
    FOnAfterPrnTxtNDok: TNotifyEvent;
    FOnBeforeCloseNDok: TNotifyEvent;
    FOnAfterCloseNDok: TNotifyEvent;
    FOnError: TNotifyEvent;
    FIntf: IE950DriverX;
    function GetControlInterface: IE950DriverX;
    function Get_HeaderCheck(ind: Integer): WideString;
    procedure Set_HeaderCheck(ind: Integer; const index: WideString);
    function Get_CashBox(BoxNo: Integer): WordBool;
    procedure Set_CashBox(BoxNo: Integer; Value: WordBool);
  protected
    procedure CreateControl;
    procedure InitControlData; override;
  public
    function Connect: WordBool;
    procedure Disconnect;
    function Connected: WordBool;
    function IsPolling: WordBool;
    procedure PausePolling;
    procedure ContinuePolling;
    function FlushBuffers(inBuf: WordBool; outBuf: WordBool): WordBool;
    function CountRX: Integer;
    function OutFreeSpace: Smallint;
    procedure ToggleDTR(onOff: WordBool);
    procedure ToggleRTS(onOff: WordBool);
    procedure TestFBlock(PrintDok: WordBool; var CountBlock: Integer; var CountSuccBlock: Integer;
      var CountErrorBlock: Integer; var CountFreeBlock: Integer);
    procedure ReportDiag;
    procedure SetBlockWorkMem(SetOf: Integer; const InfoBlock: WideString);
    function GetBlockWorkMem(SetOf: Integer; LenBlock: Integer): WideString;
    procedure PrintTestPrinter;
    procedure ResetRegistrator;
    procedure GetStatusRegistrator(var LastFDok: Integer; var FirstDokDateTime: TDateTime;
      var LastClose: Integer; var CountFiskals: Integer;
      var VersionROM: WideString; var Lastdate: TDateTime;
      var SumMoney: Currency);
    procedure GetDmpSertificate(Send2Print: WordBool; var SN: WideString; var PosPoint: Integer;
      var Devaluations: Integer; var CurrDef: Integer;
      var TypePrn: Integer; var PasswordFiskal: WideString;
      var PasswordUser: WideString; var DateSer: TDateTime);
    procedure LoadSertificate(const SN: WideString; PosPoint: Integer; Devaluations: Integer;
      CurrDef: Integer; TypePrn: Integer; const PasswordFiskal: WideString;
      const PasswordUser: WideString; DateSer: TDateTime);
    procedure Certification;
    procedure GetDmpFiskal(SendToPrint: WordBool; var RN: WideString; var UserFR: WideString;
      var PasswordFiskal: WideString; var PasswordUser: WideString;
      var DateReg: TDateTime);
    procedure LoadFiskal(const RN: WideString; const UserFR: WideString;
      const PasswordFiskal: WideString; const PasswordUser: WideString;
      DateReg: Double);
    procedure Fiskalization;
    procedure GetFMemSize(var AllMem: Integer; var UsesMem: Integer);
    procedure CloseSmena(Fix: WordBool; var NumClose: Integer; var CountFCheckComplect: Integer;
      var CountFCheckNotComplect: Integer; var CountFDokComplect: Integer;
      var CountFDokNotComplect: Integer; var CountFDokAnulComplect: Integer;
      var CountCheckDokService: Integer; var SumSale: Currency;
      var SumMargin: Currency; var SumDiscount: Currency;
      var SumContainer: Currency; var CountCheckDokBack: Integer;
      var SumSaleBack: Currency; var SumMarginBack: Currency;
      var SumDiscountBack: Currency; var SumContainerBack: Currency;
      var CountCheckDokPayment: Integer; var SumPension: Currency;
      var SumTranslation: Currency; var SumComission: Currency;
      var CountCheckDokPaymentBack: Integer; var SumPensionBack: Currency;
      var SumTranslationBack: Currency; var SumComissionBack: Currency;
      var CountCheckDokCashe: Integer; var SumCashe: Currency;
      var CountCheckDokCasheBack: Integer; var SumCasheBack: Currency);
    procedure ReportOfDates(BeginDate: Double; EndDate: Double; ItogOnly: WordBool);
    procedure ReportOfSmena(BeginSmena: Integer; EndSmena: Integer; ItogOnly: WordBool);
    function ChangePassword(const PasswordOld: WideString; const PasswordNew: WideString): WideString;
    procedure OpenCheck(TypeCheck: TxTypeCheck; IndxCurr: Integer);
    procedure PrintFiskalTxt(IndxDesc: Integer; const FiskalTxt: WideString);
    procedure PrintFiskalStr(IndxDescStr: Integer; const DefineDescStr: WideString; Count: Double;
      IndxDescUM: Integer; Price: Currency; IndxDescCurr: Integer;
      const TypeStr: WideString; ProcMargine: Double; ProcDiscount: Double);
    procedure SubTotal(PrintSubTotal: WordBool; PrintCheck: WordBool; IndxDescSubTotal: Integer;
      const DefineSubTotal: WideString; IndxDescCurr: Integer;
      ProcMargine: Integer; ProcDiscount: Integer; var TypeCheck: TxTypeCheck;
      var CountLine: Integer; var TotalSale: Currency; var TotalMargine: Currency;
      var TotalDiscount: Currency; var TotalContainer: Currency;
      var InCash: Currency);
    function CheckTotal(InSum: Currency; IndxCurr: Integer; IndxOpl: Integer;
      const DefOpl: WideString; Tender: WordBool): Currency;
    function CloseCheck: Integer;
    procedure OpenNFCheck(IndxNCheck: Integer; const DefineDescNCheck: WideString);
    procedure PrintNFText(const Str: WideString);
    procedure CloseNFCheck;
    procedure CutNFCheck;
    procedure FeedLineCheck(CountLine: Integer);
    procedure FeedLineLog(CountLine: Integer);
    procedure FeedLineBoth(CountLine: Integer);
    procedure FeedLineDok(CountLine: Integer);
    procedure EjectDok;
    function ConditionSLIP(CountFreeLine: Integer; Pos1: Integer; Pos2: Integer): Integer;
    procedure FontPrn(Font: Integer);
    procedure OpenFDok(TDok: TxTypeDok; IndxDescCurr: Integer; CountFreeLine: Integer;
      PosHeader1: Integer; PosDisc: Integer; LenDisc: Integer;
      PosDefineDesc: Integer; LenDefineDesc: Integer; PosDescStr: Integer;
      LenDescStr: Integer; PosDefineStr: Integer; LenDefgineDescStr: Integer;
      PosSum: Integer; LenSum: Integer; PosDescTotal: Integer;
      LenDescTotal: Integer; PosDefineTotal: Integer; LenDefineToTal: Integer;
      PosSumTotal: Integer; LenSumTotal: Integer; PosHeader2: Integer);
    procedure PrintDefineFDok(IndxDesc: Integer; const DefineFDok: WideString);
    procedure PrintStrFDok(IndxDescStr: Integer; const DefineDescStr: WideString; Count: Double;
      IndxDescUM: Integer; Price: Currency; IndxDescCurr: Integer;
      const TypeStr: WideString; ProcMargine: Double; ProcDiscount: Double);
    procedure SubTotalFDok(PrintDok: WordBool; IndxDescSubTotal: Integer;
      const DefineSubTotal: WideString; IndDescCurr: Integer;
      ProcMargine: Double; ProcDiscount: Double; var TDok: TxTypeDok;
      var CountLine: Integer; var TotalSale: Currency;
      var TotalMargine: Currency; var TotalDiscount: Currency;
      var TotalContainer: Currency; var InCashe: Currency);
    function TotalFDok(InSum: Currency; IndxCurr: Integer; IndxOpl: Integer;
      const DefOpl: WideString; Tender: WordBool): Currency;
    function CloseFDok: Integer;
    procedure OpenNDok(IndxDesc: Integer; const DefIndxDesc: WideString; EmptyStr: Integer;
      PosHeader1: Integer; PosHeader2: Integer);
    procedure PrintNDokStr(const Str: WideString);
    procedure CloseNDok;
    function GetDefineDesc(NumTbl: Integer; NumDesc: Integer): WideString;
    procedure SetDefineDesc(NumTbl: Integer; NumDesc: Integer; const DefineDesc: WideString);
    function GetControlsAlignment: TxAlignment;
    procedure FlipChildren(AllLevels: WordBool);
    function DrawTextBiDiModeFlags(Flags: Integer): Integer;
    function DrawTextBiDiModeFlagsReadingOnly: Integer;
    procedure InitiateAction;
    function IsRightToLeft: WordBool;
    function UseRightToLeftAlignment: WordBool;
    function UseRightToLeftReading: WordBool;
    function UseRightToLeftScrollBar: WordBool;
    function ClassNameIs(const Name: WideString): WordBool;
    function LR(const Param: WideString): WideString;
    function GetHeaderCheck(idx: Integer): WideString;
    procedure SetHeaderCheck(idx: Integer; const newval: WideString);
    procedure OpenCashBox(Ano: Integer);
    property ControlInterface: IE950DriverX read GetControlInterface;
    property TrainingState: WordBool index 59 read GetWordBoolProp write SetWordBoolProp;
    property CashireName: WideString index 60 read GetWideStringProp write SetWideStringProp;
    property Password: WideString index 61 read GetWideStringProp write SetWideStringProp;
    property InspPassword: WideString index 62 read GetWideStringProp write SetWideStringProp;
    property DateTimeFR: TDateTime index 63 read GetTDateTimeProp write SetTDateTimeProp;
    property ErrorStr: WideString index 64 read GetWideStringProp;
    property DoubleBuffered: WordBool index 84 read GetWordBoolProp write SetWordBoolProp;
    property Enabled: WordBool index - 514 read GetWordBoolProp write SetWordBoolProp;
    property BiDiMode: TOleEnum index 100 read GetTOleEnumProp write SetTOleEnumProp;
    property Visible: WordBool index 101 read GetWordBoolProp write SetWordBoolProp;
    property HeaderCheck[ind: Integer]: WideString read Get_HeaderCheck write Set_HeaderCheck;
    property CashBox[BoxNo: Integer]: WordBool read Get_CashBox write Set_CashBox;
  published
    property Align;
    property DragCursor;
    property DragMode;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnStartDrag;
    property Port: TOleEnum index 65 read GetTOleEnumProp write SetTOleEnumProp stored False;
    property PortName: WideString index 66 read GetWideStringProp write SetWideStringProp stored False;
    property BaudRate: TOleEnum index 67 read GetTOleEnumProp write SetTOleEnumProp stored False;
    property BaudRateValue: Integer index 68 read GetIntegerProp write SetIntegerProp stored False;
    property DataBits: TOleEnum index 69 read GetTOleEnumProp write SetTOleEnumProp stored False;
    property StopBits: TOleEnum index 70 read GetTOleEnumProp write SetTOleEnumProp stored False;
    property Parity: TOleEnum index 71 read GetTOleEnumProp write SetTOleEnumProp stored False;
    property HwFlow: TOleEnum index 72 read GetTOleEnumProp write SetTOleEnumProp stored False;
    property SwFlow: TOleEnum index 73 read GetTOleEnumProp write SetTOleEnumProp stored False;
    property InBufSize: Integer index 74 read GetIntegerProp write SetIntegerProp stored False;
    property OutBufSize: Integer index 75 read GetIntegerProp write SetIntegerProp stored False;
    property PollingDelay: Integer index 76 read GetIntegerProp write SetIntegerProp stored False;
    property EnableDTROnOpen: WordBool index 77 read GetWordBoolProp write SetWordBoolProp stored False;
    property OutputTimeout: Integer index 78 read GetIntegerProp write SetIntegerProp stored False;
    property InputTimeout: Integer index 79 read GetIntegerProp write SetIntegerProp stored False;
    property CheckLineStatus: WordBool index 80 read GetWordBoolProp write SetWordBoolProp stored False;
    property Cursor: Smallint index 102 read GetSmallintProp write SetSmallintProp stored False;
    property OnBeforeOpenCheck: TNotifyEvent read FOnBeforeOpenCheck write FOnBeforeOpenCheck;
    property OnAfterOpenCheck: TNotifyEvent read FOnAfterOpenCheck write FOnAfterOpenCheck;
    property OnBeforePrnTxtCheck: TNotifyEvent read FOnBeforePrnTxtCheck write FOnBeforePrnTxtCheck;
    property OnAfterPrnTxtCheck: TNotifyEvent read FOnAfterPrnTxtCheck write FOnAfterPrnTxtCheck;
    property OnBeforePrnStrCheck: TNotifyEvent read FOnBeforePrnStrCheck write FOnBeforePrnStrCheck;
    property OnAfterPrnStrCheck: TNotifyEvent read FOnAfterPrnStrCheck write FOnAfterPrnStrCheck;
    property OnBeforePrnSubTotalCheck: TNotifyEvent read FOnBeforePrnSubTotalCheck write FOnBeforePrnSubTotalCheck;
    property OnAfterPrnSubTotalCheck: TNotifyEvent read FOnAfterPrnSubTotalCheck write FOnAfterPrnSubTotalCheck;
    property OnBeforePrnTotalCheck: TNotifyEvent read FOnBeforePrnTotalCheck write FOnBeforePrnTotalCheck;
    property OnAfterPrnTotalCheck: TNotifyEvent read FOnAfterPrnTotalCheck write FOnAfterPrnTotalCheck;
    property OnBeforeCloseCheck: TNotifyEvent read FOnBeforeCloseCheck write FOnBeforeCloseCheck;
    property OnAfterCloseCheck: TNotifyEvent read FOnAfterCloseCheck write FOnAfterCloseCheck;
    property OnBeforeOpenNCheck: TNotifyEvent read FOnBeforeOpenNCheck write FOnBeforeOpenNCheck;
    property OnAfterOpenNCheck: TNotifyEvent read FOnAfterOpenNCheck write FOnAfterOpenNCheck;
    property OnBeforePrnTxtNCheck: TNotifyEvent read FOnBeforePrnTxtNCheck write FOnBeforePrnTxtNCheck;
    property OnAfterPrnTxtNCheck: TNotifyEvent read FOnAfterPrnTxtNCheck write FOnAfterPrnTxtNCheck;
    property OnBeforeCloseNCheck: TNotifyEvent read FOnBeforeCloseNCheck write FOnBeforeCloseNCheck;
    property OnAfterCloseNCheck: TNotifyEvent read FOnAfterCloseNCheck write FOnAfterCloseNCheck;
    property OnBeforeOpenDok: TNotifyEvent read FOnBeforeOpenDok write FOnBeforeOpenDok;
    property OnAfterOpenDok: TNotifyEvent read FOnAfterOpenDok write FOnAfterOpenDok;
    property OnBeforePrnTxtDok: TNotifyEvent read FOnBeforePrnTxtDok write FOnBeforePrnTxtDok;
    property OnAfterPrnTxtDok: TNotifyEvent read FOnAfterPrnTxtDok write FOnAfterPrnTxtDok;
    property OnBeforePrnStrDok: TNotifyEvent read FOnBeforePrnStrDok write FOnBeforePrnStrDok;
    property OnAfterPrnStrDok: TNotifyEvent read FOnAfterPrnStrDok write FOnAfterPrnStrDok;
    property OnBeforePrnSubTotalDok: TNotifyEvent read FOnBeforePrnSubTotalDok write FOnBeforePrnSubTotalDok;
    property OnAfterPrnSubTotalDok: TNotifyEvent read FOnAfterPrnSubTotalDok write FOnAfterPrnSubTotalDok;
    property OnBeforePrnTotalDok: TNotifyEvent read FOnBeforePrnTotalDok write FOnBeforePrnTotalDok;
    property OnAfterPrnTotalDok: TNotifyEvent read FOnAfterPrnTotalDok write FOnAfterPrnTotalDok;
    property OnBeforeCloseDok: TNotifyEvent read FOnBeforeCloseDok write FOnBeforeCloseDok;
    property OnAfterCloseDok: TNotifyEvent read FOnAfterCloseDok write FOnAfterCloseDok;
    property OnBeforeOpenNDok: TNotifyEvent read FOnBeforeOpenNDok write FOnBeforeOpenNDok;
    property OnAfterOpenNDok: TNotifyEvent read FOnAfterOpenNDok write FOnAfterOpenNDok;
    property OnBeforePrnTxtNDok: TNotifyEvent read FOnBeforePrnTxtNDok write FOnBeforePrnTxtNDok;
    property OnAfterPrnTxtNDok: TNotifyEvent read FOnAfterPrnTxtNDok write FOnAfterPrnTxtNDok;
    property OnBeforeCloseNDok: TNotifyEvent read FOnBeforeCloseNDok write FOnBeforeCloseNDok;
    property OnAfterCloseNDok: TNotifyEvent read FOnAfterCloseNDok write FOnAfterCloseNDok;
    property OnError: TNotifyEvent read FOnError write FOnError;
  end;

procedure Register;

implementation

uses ComObj;

procedure TE950DriverX.InitControlData;
const
  CEventDispIDs: array[0..36] of DWORD = (
    $00000003, $00000004, $00000005, $00000006, $00000007, $00000008,
    $00000009, $0000000A, $0000000B, $0000000C, $0000000D, $0000000E,
    $0000000F, $00000010, $00000011, $00000012, $00000013, $00000014,
    $00000015, $00000016, $00000017, $00000018, $00000019, $0000001A,
    $0000001B, $0000001C, $0000001D, $0000001E, $0000001F, $00000020,
    $00000021, $00000022, $00000023, $00000024, $00000025, $00000026,
    $00000027);
  CControlData: TControlData2 = (
    ClassID: '{D7D7292F-8550-4AD7-B9C2-C7BE9B9F91BC}';
    EventIID: '{CCB9AF31-BE6E-47E9-9270-7BD0CC851D4A}';
    EventCount: 37;
    EventDispIDs: @CEventDispIDs;
    LicenseKey: nil;
    Flags: $00000008;
    Version: 401);
begin
  ControlData := @CControlData;
  TControlData2(CControlData).FirstEventOfs := Cardinal(@@FOnBeforeOpenCheck) - Cardinal(Self);
end;

procedure TE950DriverX.CreateControl;

  procedure DoCreate;
  begin
    FIntf := IUnknown(OleObject) as IE950DriverX;
  end;

begin
  if FIntf = nil then DoCreate;
end;

function TE950DriverX.GetControlInterface: IE950DriverX;
begin
  CreateControl;
  Result := FIntf;
end;

function TE950DriverX.Get_HeaderCheck(ind: Integer): WideString;
begin
  Result := ControlInterface.Get_HeaderCheck(ind);
end;

procedure TE950DriverX.Set_HeaderCheck(ind: Integer; const index: WideString);
begin
  ControlInterface.Set_HeaderCheck(ind, index);
end;

function TE950DriverX.Get_CashBox(BoxNo: Integer): WordBool;
begin
  Result := ControlInterface.Get_CashBox(BoxNo);
end;

procedure TE950DriverX.Set_CashBox(BoxNo: Integer; Value: WordBool);
begin
  ControlInterface.Set_CashBox(BoxNo, Value);
end;

function TE950DriverX.Connect: WordBool;
begin
  Result := ControlInterface.Connect;
end;

procedure TE950DriverX.Disconnect;
begin
  ControlInterface.Disconnect;
end;

function TE950DriverX.Connected: WordBool;
begin
  Result := ControlInterface.Connected;
end;

function TE950DriverX.IsPolling: WordBool;
begin
  Result := ControlInterface.IsPolling;
end;

procedure TE950DriverX.PausePolling;
begin
  ControlInterface.PausePolling;
end;

procedure TE950DriverX.ContinuePolling;
begin
  ControlInterface.ContinuePolling;
end;

function TE950DriverX.FlushBuffers(inBuf: WordBool; outBuf: WordBool): WordBool;
begin
  Result := ControlInterface.FlushBuffers(inBuf, outBuf);
end;

function TE950DriverX.CountRX: Integer;
begin
  Result := ControlInterface.CountRX;
end;

function TE950DriverX.OutFreeSpace: Smallint;
begin
  Result := ControlInterface.OutFreeSpace;
end;

procedure TE950DriverX.ToggleDTR(onOff: WordBool);
begin
  ControlInterface.ToggleDTR(onOff);
end;

procedure TE950DriverX.ToggleRTS(onOff: WordBool);
begin
  ControlInterface.ToggleRTS(onOff);
end;

procedure TE950DriverX.TestFBlock(PrintDok: WordBool; var CountBlock: Integer;
  var CountSuccBlock: Integer; var CountErrorBlock: Integer;
  var CountFreeBlock: Integer);
begin
  ControlInterface.TestFBlock(PrintDok, CountBlock, CountSuccBlock, CountErrorBlock, CountFreeBlock);
end;

procedure TE950DriverX.ReportDiag;
begin
  ControlInterface.ReportDiag;
end;

procedure TE950DriverX.SetBlockWorkMem(SetOf: Integer; const InfoBlock: WideString);
begin
  ControlInterface.SetBlockWorkMem(SetOf, InfoBlock);
end;

function TE950DriverX.GetBlockWorkMem(SetOf: Integer; LenBlock: Integer): WideString;
begin
  Result := ControlInterface.GetBlockWorkMem(SetOf, LenBlock);
end;

procedure TE950DriverX.PrintTestPrinter;
begin
  ControlInterface.PrintTestPrinter;
end;

procedure TE950DriverX.ResetRegistrator;
begin
  ControlInterface.ResetRegistrator;
end;

procedure TE950DriverX.GetStatusRegistrator(var LastFDok: Integer; var FirstDokDateTime: TDateTime;
  var LastClose: Integer; var CountFiskals: Integer;
  var VersionROM: WideString; var Lastdate: TDateTime;
  var SumMoney: Currency);
begin
  ControlInterface.GetStatusRegistrator(LastFDok, FirstDokDateTime, LastClose, CountFiskals,
    VersionROM, Lastdate, SumMoney);
end;

procedure TE950DriverX.GetDmpSertificate(Send2Print: WordBool; var SN: WideString;
  var PosPoint: Integer; var Devaluations: Integer;
  var CurrDef: Integer; var TypePrn: Integer;
  var PasswordFiskal: WideString;
  var PasswordUser: WideString; var DateSer: TDateTime);
begin
  ControlInterface.GetDmpSertificate(Send2Print, SN, PosPoint, Devaluations, CurrDef, TypePrn,
    PasswordFiskal, PasswordUser, DateSer);
end;

procedure TE950DriverX.LoadSertificate(const SN: WideString; PosPoint: Integer;
  Devaluations: Integer; CurrDef: Integer; TypePrn: Integer;
  const PasswordFiskal: WideString;
  const PasswordUser: WideString; DateSer: TDateTime);
begin
  ControlInterface.LoadSertificate(SN, PosPoint, Devaluations, CurrDef, TypePrn, PasswordFiskal,
    PasswordUser, DateSer);
end;

procedure TE950DriverX.Certification;
begin
  ControlInterface.Certification;
end;

procedure TE950DriverX.GetDmpFiskal(SendToPrint: WordBool; var RN: WideString;
  var UserFR: WideString; var PasswordFiskal: WideString;
  var PasswordUser: WideString; var DateReg: TDateTime);
begin
  ControlInterface.GetDmpFiskal(SendToPrint, RN, UserFR, PasswordFiskal, PasswordUser, DateReg);
end;

procedure TE950DriverX.LoadFiskal(const RN: WideString; const UserFR: WideString;
  const PasswordFiskal: WideString; const PasswordUser: WideString;
  DateReg: Double);
begin
  ControlInterface.LoadFiskal(RN, UserFR, PasswordFiskal, PasswordUser, DateReg);
end;

procedure TE950DriverX.Fiskalization;
begin
  ControlInterface.Fiskalization;
end;

procedure TE950DriverX.GetFMemSize(var AllMem: Integer; var UsesMem: Integer);
begin
  ControlInterface.GetFMemSize(AllMem, UsesMem);
end;

procedure TE950DriverX.CloseSmena(Fix: WordBool; var NumClose: Integer;
  var CountFCheckComplect: Integer;
  var CountFCheckNotComplect: Integer;
  var CountFDokComplect: Integer;
  var CountFDokNotComplect: Integer;
  var CountFDokAnulComplect: Integer;
  var CountCheckDokService: Integer; var SumSale: Currency;
  var SumMargin: Currency; var SumDiscount: Currency;
  var SumContainer: Currency; var CountCheckDokBack: Integer;
  var SumSaleBack: Currency; var SumMarginBack: Currency;
  var SumDiscountBack: Currency; var SumContainerBack: Currency;
  var CountCheckDokPayment: Integer; var SumPension: Currency;
  var SumTranslation: Currency; var SumComission: Currency;
  var CountCheckDokPaymentBack: Integer;
  var SumPensionBack: Currency; var SumTranslationBack: Currency;
  var SumComissionBack: Currency; var CountCheckDokCashe: Integer;
  var SumCashe: Currency; var CountCheckDokCasheBack: Integer;
  var SumCasheBack: Currency);
begin
  ControlInterface.CloseSmena(Fix, NumClose, CountFCheckComplect, CountFCheckNotComplect,
    CountFDokComplect, CountFDokNotComplect, CountFDokAnulComplect,
    CountCheckDokService, SumSale, SumMargin, SumDiscount, SumContainer,
    CountCheckDokBack, SumSaleBack, SumMarginBack, SumDiscountBack,
    SumContainerBack, CountCheckDokPayment, SumPension, SumTranslation,
    SumComission, CountCheckDokPaymentBack, SumPensionBack,
    SumTranslationBack, SumComissionBack, CountCheckDokCashe, SumCashe,
    CountCheckDokCasheBack, SumCasheBack);
end;

procedure TE950DriverX.ReportOfDates(BeginDate: Double; EndDate: Double; ItogOnly: WordBool);
begin
  ControlInterface.ReportOfDates(BeginDate, EndDate, ItogOnly);
end;

procedure TE950DriverX.ReportOfSmena(BeginSmena: Integer; EndSmena: Integer; ItogOnly: WordBool);
begin
  ControlInterface.ReportOfSmena(BeginSmena, EndSmena, ItogOnly);
end;

function TE950DriverX.ChangePassword(const PasswordOld: WideString; const PasswordNew: WideString): WideString;
begin
  Result := ControlInterface.ChangePassword(PasswordOld, PasswordNew);
end;

procedure TE950DriverX.OpenCheck(TypeCheck: TxTypeCheck; IndxCurr: Integer);
begin
  ControlInterface.OpenCheck(TypeCheck, IndxCurr);
end;

procedure TE950DriverX.PrintFiskalTxt(IndxDesc: Integer; const FiskalTxt: WideString);
begin
  ControlInterface.PrintFiskalTxt(IndxDesc, FiskalTxt);
end;

procedure TE950DriverX.PrintFiskalStr(IndxDescStr: Integer; const DefineDescStr: WideString;
  Count: Double; IndxDescUM: Integer; Price: Currency;
  IndxDescCurr: Integer; const TypeStr: WideString;
  ProcMargine: Double; ProcDiscount: Double);
begin
  ControlInterface.PrintFiskalStr(IndxDescStr, DefineDescStr, Count, IndxDescUM, Price,
    IndxDescCurr, TypeStr, ProcMargine, ProcDiscount);
end;

procedure TE950DriverX.SubTotal(PrintSubTotal: WordBool; PrintCheck: WordBool;
  IndxDescSubTotal: Integer; const DefineSubTotal: WideString;
  IndxDescCurr: Integer; ProcMargine: Integer; ProcDiscount: Integer;
  var TypeCheck: TxTypeCheck; var CountLine: Integer;
  var TotalSale: Currency; var TotalMargine: Currency;
  var TotalDiscount: Currency; var TotalContainer: Currency;
  var InCash: Currency);
begin
  ControlInterface.SubTotal(PrintSubTotal, PrintCheck, IndxDescSubTotal, DefineSubTotal,
    IndxDescCurr, ProcMargine, ProcDiscount, TypeCheck, CountLine,
    TotalSale, TotalMargine, TotalDiscount, TotalContainer, InCash);
end;

function TE950DriverX.CheckTotal(InSum: Currency; IndxCurr: Integer; IndxOpl: Integer;
  const DefOpl: WideString; Tender: WordBool): Currency;
begin
  Result := ControlInterface.CheckTotal(InSum, IndxCurr, IndxOpl, DefOpl, Tender);
end;

function TE950DriverX.CloseCheck: Integer;
begin
  Result := ControlInterface.CloseCheck;
end;

procedure TE950DriverX.OpenNFCheck(IndxNCheck: Integer; const DefineDescNCheck: WideString);
begin
  ControlInterface.OpenNFCheck(IndxNCheck, DefineDescNCheck);
end;

procedure TE950DriverX.PrintNFText(const Str: WideString);
begin
  ControlInterface.PrintNFText(Str);
end;

procedure TE950DriverX.CloseNFCheck;
begin
  ControlInterface.CloseNFCheck;
end;

procedure TE950DriverX.CutNFCheck;
begin
  ControlInterface.CutNFCheck;
end;

procedure TE950DriverX.FeedLineCheck(CountLine: Integer);
begin
  ControlInterface.FeedLineCheck(CountLine);
end;

procedure TE950DriverX.FeedLineLog(CountLine: Integer);
begin
  ControlInterface.FeedLineLog(CountLine);
end;

procedure TE950DriverX.FeedLineBoth(CountLine: Integer);
begin
  ControlInterface.FeedLineBoth(CountLine);
end;

procedure TE950DriverX.FeedLineDok(CountLine: Integer);
begin
  ControlInterface.FeedLineDok(CountLine);
end;

procedure TE950DriverX.EjectDok;
begin
  ControlInterface.EjectDok;
end;

function TE950DriverX.ConditionSLIP(CountFreeLine: Integer; Pos1: Integer; Pos2: Integer): Integer;
begin
  Result := ControlInterface.ConditionSLIP(CountFreeLine, Pos1, Pos2);
end;

procedure TE950DriverX.FontPrn(Font: Integer);
begin
  ControlInterface.FontPrn(Font);
end;

procedure TE950DriverX.OpenFDok(TDok: TxTypeDok; IndxDescCurr: Integer; CountFreeLine: Integer;
  PosHeader1: Integer; PosDisc: Integer; LenDisc: Integer;
  PosDefineDesc: Integer; LenDefineDesc: Integer;
  PosDescStr: Integer; LenDescStr: Integer; PosDefineStr: Integer;
  LenDefgineDescStr: Integer; PosSum: Integer; LenSum: Integer;
  PosDescTotal: Integer; LenDescTotal: Integer;
  PosDefineTotal: Integer; LenDefineToTal: Integer;
  PosSumTotal: Integer; LenSumTotal: Integer; PosHeader2: Integer);
begin
  ControlInterface.OpenFDok(TDok, IndxDescCurr, CountFreeLine, PosHeader1, PosDisc, LenDisc,
    PosDefineDesc, LenDefineDesc, PosDescStr, LenDescStr, PosDefineStr,
    LenDefgineDescStr, PosSum, LenSum, PosDescTotal, LenDescTotal,
    PosDefineTotal, LenDefineToTal, PosSumTotal, LenSumTotal, PosHeader2);
end;

procedure TE950DriverX.PrintDefineFDok(IndxDesc: Integer; const DefineFDok: WideString);
begin
  ControlInterface.PrintDefineFDok(IndxDesc, DefineFDok);
end;

procedure TE950DriverX.PrintStrFDok(IndxDescStr: Integer; const DefineDescStr: WideString;
  Count: Double; IndxDescUM: Integer; Price: Currency;
  IndxDescCurr: Integer; const TypeStr: WideString;
  ProcMargine: Double; ProcDiscount: Double);
begin
  ControlInterface.PrintStrFDok(IndxDescStr, DefineDescStr, Count, IndxDescUM, Price, IndxDescCurr,
    TypeStr, ProcMargine, ProcDiscount);
end;

procedure TE950DriverX.SubTotalFDok(PrintDok: WordBool; IndxDescSubTotal: Integer;
  const DefineSubTotal: WideString; IndDescCurr: Integer;
  ProcMargine: Double; ProcDiscount: Double; var TDok: TxTypeDok;
  var CountLine: Integer; var TotalSale: Currency;
  var TotalMargine: Currency; var TotalDiscount: Currency;
  var TotalContainer: Currency; var InCashe: Currency);
begin
  ControlInterface.SubTotalFDok(PrintDok, IndxDescSubTotal, DefineSubTotal, IndDescCurr,
    ProcMargine, ProcDiscount, TDok, CountLine, TotalSale,
    TotalMargine, TotalDiscount, TotalContainer, InCashe);
end;

function TE950DriverX.TotalFDok(InSum: Currency; IndxCurr: Integer; IndxOpl: Integer;
  const DefOpl: WideString; Tender: WordBool): Currency;
begin
  Result := ControlInterface.TotalFDok(InSum, IndxCurr, IndxOpl, DefOpl, Tender);
end;

function TE950DriverX.CloseFDok: Integer;
begin
  Result := ControlInterface.CloseFDok;
end;

procedure TE950DriverX.OpenNDok(IndxDesc: Integer; const DefIndxDesc: WideString;
  EmptyStr: Integer; PosHeader1: Integer; PosHeader2: Integer);
begin
  ControlInterface.OpenNDok(IndxDesc, DefIndxDesc, EmptyStr, PosHeader1, PosHeader2);
end;

procedure TE950DriverX.PrintNDokStr(const Str: WideString);
begin
  ControlInterface.PrintNDokStr(Str);
end;

procedure TE950DriverX.CloseNDok;
begin
  ControlInterface.CloseNDok;
end;

function TE950DriverX.GetDefineDesc(NumTbl: Integer; NumDesc: Integer): WideString;
begin
  Result := ControlInterface.GetDefineDesc(NumTbl, NumDesc);
end;

procedure TE950DriverX.SetDefineDesc(NumTbl: Integer; NumDesc: Integer; const DefineDesc: WideString);
begin
  ControlInterface.SetDefineDesc(NumTbl, NumDesc, DefineDesc);
end;

function TE950DriverX.GetControlsAlignment: TxAlignment;
begin
  Result := ControlInterface.GetControlsAlignment;
end;

procedure TE950DriverX.FlipChildren(AllLevels: WordBool);
begin
  ControlInterface.FlipChildren(AllLevels);
end;

function TE950DriverX.DrawTextBiDiModeFlags(Flags: Integer): Integer;
begin
  Result := ControlInterface.DrawTextBiDiModeFlags(Flags);
end;

function TE950DriverX.DrawTextBiDiModeFlagsReadingOnly: Integer;
begin
  Result := ControlInterface.DrawTextBiDiModeFlagsReadingOnly;
end;

procedure TE950DriverX.InitiateAction;
begin
  ControlInterface.InitiateAction;
end;

function TE950DriverX.IsRightToLeft: WordBool;
begin
  Result := ControlInterface.IsRightToLeft;
end;

function TE950DriverX.UseRightToLeftAlignment: WordBool;
begin
  Result := ControlInterface.UseRightToLeftAlignment;
end;

function TE950DriverX.UseRightToLeftReading: WordBool;
begin
  Result := ControlInterface.UseRightToLeftReading;
end;

function TE950DriverX.UseRightToLeftScrollBar: WordBool;
begin
  Result := ControlInterface.UseRightToLeftScrollBar;
end;

function TE950DriverX.ClassNameIs(const Name: WideString): WordBool;
begin
  Result := ControlInterface.ClassNameIs(Name);
end;

function TE950DriverX.LR(const Param: WideString): WideString;
begin
  Result := ControlInterface.LR(Param);
end;

function TE950DriverX.GetHeaderCheck(idx: Integer): WideString;
begin
  Result := ControlInterface.GetHeaderCheck(idx);
end;

procedure TE950DriverX.SetHeaderCheck(idx: Integer; const newval: WideString);
begin
  ControlInterface.SetHeaderCheck(idx, newval);
end;

procedure TE950DriverX.OpenCashBox(Ano: Integer);
begin
  ControlInterface.OpenCashBox(Ano);
end;

procedure Register;
begin
  RegisterComponents('ActiveX', [TE950DriverX]);
end;

end.

