//------------------------------------------------------------------------
// UNIT           : E950DrvWCReg.pas
// CONTENTS       : TE950Driver component
// VERSION        : 1.0
// TARGET         : (Inprise's) Borland Delphi 4.0
// AUTHORS         : Konstantin Grishenko, Andrey Ivanov, Dmitry Myarikianov, Marco Cocco
// STATUS         : Freeware
//------------------------------------------------------------------------
//
// Copyright (c) 1996-98 by Konstantin Grishenko, Andrey Ivanov, Dmitry Myarikianov. All rights reseved.
// Copyright (c) 1996-98 by Marco Cocco. All rights reseved.
// Copyright (c) 1996-98 by d3k Software Company. All rights reseved.
//
// NO REPRESENTATIONS ARE MADE ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
//    PURPOSE. IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
//   NEITHER MARCO COCCO OR D3K SHALL BE LIABLE FOR ANY DAMAGES SUFFERED BY
//                          THE USE OF THIS SOFTWARE.
//

unit E950DrvWCReg;

interface

procedure Register;

implementation

uses
  // Delphi units
  Classes,
  // ComDrv32 units
  E950Drv1;

//{$R E950Drv.dcr}

const
  TargetTab = 'Udo';

procedure Register;
begin
  RegisterComponents(TargetTab, [E950Drv1.TE950Driver]);
end;

end.

