//------------------------------------------------------------------------
// UNIT           : tstE950.pas
// CONTENTS       : TE950Driver component test program
// VERSION        : 1.0
// TARGET         : (Inprise's) Borland Delphi 4.0
// AUTHORS         : Konstantin Grishenko, Andrey Ivanov, Dmitry Myarikianov, Marco Cocco
// STATUS         : Freeware
//------------------------------------------------------------------------
//
// Copyright (c) 1996-98 by Konstantin Grishenko, Andrey Ivanov, Dmitry Myarikianov. All rights reseved.
// Copyright (c) 1996-98 by Marco Cocco. All rights reseved.
// Copyright (c) 1996-98 by d3k Software Company. All rights reseved.
//
// NO REPRESENTATIONS ARE MADE ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY
//    PURPOSE. IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
//   NEITHER MARCO COCCO OR D3K SHALL BE LIABLE FOR ANY DAMAGES SUFFERED BY
//                          THE USE OF THIS SOFTWARE.
//

unit tstE950;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, E950Drv1;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    E950: TE950Driver;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
  var NumClose, CountFCheckComplect, CountFCheckNotComplect, CountFDokComplect,
  CountFDokNotComplect, CountFDokAnulComplect,CountCheckDokService,CountCheckDokPayment,CountCheckDokCashe,
  CountCheckDokCasheBack,CountCheckDokPaymentBack,CountCheckDokBack: Integer;

  SumSale, SumMargin, SumDiscount, SumContainer,SumSaleBack,
  SumMarginBack, SumDiscountBack,SumContainerBack,SumPension,
  SumTranslation,SumComission,SumPensionBack,SumTranslationBack,
  SumComissionBack,SumCashe,SumCasheBack: Currency;
begin
  E950.Connect;
  E950.Password:= '';
  E950.CloseSmena(False, NumClose, CountFCheckComplect, CountFCheckNotComplect, CountFDokComplect,
  CountFDokNotComplect, CountFDokAnulComplect,CountCheckDokService,
  SumSale, SumMargin, SumDiscount, SumContainer,CountCheckDokBack,SumSaleBack,
  SumMarginBack, SumDiscountBack,SumContainerBack,CountCheckDokPayment,SumPension,
  SumTranslation,SumComission,CountCheckDokPaymentBack,SumPensionBack,SumTranslationBack,
  SumComissionBack,CountCheckDokCashe,SumCashe,CountCheckDokCasheBack,SumCasheBack);
  // E950.ReportTestFMem(CountBlock, CountSuccBlock, CountErrorBlock, CountFreeBlock);
  E950.Disconnect;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  E950:= TE950Driver.CreateParented(Form1.WindowHandle);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  E950.Free;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  cb, csb, ceb, cfb: Integer;
begin
  E950.Connect;
  E950.Password:= '';
  button2.Caption:= E950.HeaderCheck[2];
  E950.Disconnect;
end;

end.
